#include "tsbrowse3.h"
#pragma hdrstop

#include "tsb3_f_tools.h"
#include "tsb3_f_module.h"
#include "tsb3_f_mainm.h"
#include "tsb3_f_pnot.h"
#include "tsb3_f_resourcefile.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TToolsForm *ToolsForm;
//---------------------------------------------------------------------------
__fastcall TToolsForm::TToolsForm(TComponent* Owner)
        : TForm(Owner)
{ 
}
//---------------------------------------------------------------------------

void __fastcall TToolsForm::CloseProjectClick(TObject *Sender)
{ tools->CloseProject();

}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::OpenProjectClick(TObject *Sender)
{
tools->OpenProject(tOpenProject->Text);
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::OpenProjectInfoClick(TObject *Sender)
{
tools->OpenProjectInfo(tOpenProjectInfo->Text);
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::SaveProjectClick(TObject *Sender)
{
tools->SaveProject();
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::CloseFileClick(TObject *Sender)
{
tools->CloseFile(tCloseFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::OpenFileClick(TObject *Sender)
{
tools->OpenFile(tOpenFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::ReloadFileClick(TObject *Sender)
{
tools->ReloadFile(tReloadFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::CreateModuleClick(TObject *Sender)
{
TCreateModuleFlags mf;
if (cAddToProject->Checked) mf << cmAddToProject;
if (cShowSource->Checked) mf << cmShowSource;
if (cShowForm->Checked) mf << cmShowForm;
if (cUnNamed->Checked) mf << cmUnNamed;
if (cNewUnit->Checked) mf << cmNewUnit;
if (cNewForm->Checked) mf << cmNewForm;
//if (cNewModel->Checked) mf << cmNewModel;
if (cMainForm->Checked) mf << cmMainForm;
if (cMarkModified->Checked) mf << cmMarkModified;
if (cExisting->Checked) mf << cmExisting;
// Generate the streams
TIMemoryStream *ISourceStream,*IFormStream;
TMemoryStream *sc  =new TMemoryStream();
TMemoryStream *sf  =new TMemoryStream();
Source->Lines->SaveToStream(sc);
TForm *f=new TForm(NULL,0);
Proxies::CreateSubClass(f,"T"+FormName->Text,__classid(TForm));
f->Position=poDefaultPosOnly;
f->Name=FormName->Text;
f->Caption=FormName->Text;
f->Width=200;
f->Height=150;
sf->WriteComponentRes(FormName->Text,f);
delete f;
sc->Position=0;
sf->Position=0;
ISourceStream=new TIMemoryStream(sc);
ISourceStream->AddRef();
IFormStream=new TIMemoryStream(sf);
IFormStream->AddRef();
// Create the module!
bool res=tools->CreateModule(ModuleName->Text,
      cSource->Checked?ISourceStream:NULL,cForm->Checked?IFormStream:NULL,mf);
rCreateModule->Caption=res?"true":"false";
// Clean up
ISourceStream->OwnStream=true;
delete ISourceStream;
IFormStream->OwnStream=true;
delete IFormStream;
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::CreateModuleExClick(TObject *Sender)
{
TCreateModuleFlags mf;
if (cAddToProject->Checked) mf << cmAddToProject;
if (cShowSource->Checked) mf << cmShowSource;
if (cShowForm->Checked) mf << cmShowForm;
if (cUnNamed->Checked) mf << cmUnNamed;
if (cNewUnit->Checked) mf << cmNewUnit;
if (cNewForm->Checked) mf << cmNewForm;
//if (cNewModel->Checked) mf << cmNewModel;
if (cMainForm->Checked) mf << cmMainForm;
if (cMarkModified->Checked) mf << cmMarkModified;
if (cExisting->Checked) mf << cmExisting;
// Generate the streams
TIMemoryStream *ISourceStream,*IFormStream;
TMemoryStream *sc  =new TMemoryStream();
TMemoryStream *sf  =new TMemoryStream();
Source->Lines->SaveToStream(sc);
TForm *f=new TForm(NULL,0);
Proxies::CreateSubClass(f,"T"+FormName->Text,__classid(TForm));
f->Position=poDefaultPosOnly;
f->Name=FormName->Text;
f->Caption=FormName->Text;
f->Width=200;
f->Height=150;
sf->WriteComponentRes(FormName->Text,f);
delete f;
sc->Position=0;
sf->Position=0;
ISourceStream=new TIMemoryStream(sc);
ISourceStream->AddRef();
IFormStream=new TIMemoryStream(sf);
IFormStream->AddRef();
// Create the module!
TIModuleInterface *mi=tools->CreateModuleEx(ModuleName->Text,
      FormName->Text,AncestorClass->Text,FileSystem->Text,
      cHeaderSource->Checked?ISourceStream:NULL,cForm->Checked?IFormStream:NULL,mf);
// Clean up
ISourceStream->OwnStream=true;
delete ISourceStream;
IFormStream->OwnStream=true;
delete IFormStream;
// and do the thing
if (mi==NULL)
{ Application->MessageBox("Module interface doesn't exist","Error",MB_OK);
}
else
{ // mi->AddRef probably not needed
  TModuleForm *moduleform=new TModuleForm(this);
  moduleform->mi=mi;
  moduleform->Caption=ModuleName->Text;
  moduleform->ShowModal();
  delete moduleform;
  mi->Release();
}
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::CreateCppModuleClick(TObject *Sender)
{
TCreateModuleFlags mf;
if (cAddToProject->Checked) mf << cmAddToProject;
if (cShowSource->Checked) mf << cmShowSource;
if (cShowForm->Checked) mf << cmShowForm;
if (cUnNamed->Checked) mf << cmUnNamed;
if (cNewUnit->Checked) mf << cmNewUnit;
if (cNewForm->Checked) mf << cmNewForm;
//if (cNewModel->Checked) mf << cmNewModel;
if (cMainForm->Checked) mf << cmMainForm;
if (cMarkModified->Checked) mf << cmMarkModified;
if (cExisting->Checked) mf << cmExisting;
// Generate the streams
TIMemoryStream *ISourceStream,*IHeaderStream,*IFormStream;
TMemoryStream *sh  =new TMemoryStream();
TMemoryStream *sc  =new TMemoryStream();
TMemoryStream *sf  =new TMemoryStream();
Source->Lines->SaveToStream(sc);
HeaderSource->Lines->SaveToStream(sh);
TForm *f=new TForm(NULL,0);
Proxies::CreateSubClass(f,"T"+FormName->Text,__classid(TForm));
f->Position=poDefaultPosOnly;
f->Name=FormName->Text;
f->Caption=FormName->Text;
f->Width=200;
f->Height=150;
sf->WriteComponentRes(FormName->Text,f);
delete f;
sc->Position=0;
sf->Position=0;
sh->Position=0;
ISourceStream=new TIMemoryStream(sc);
ISourceStream->AddRef();
IFormStream=new TIMemoryStream(sf);
IFormStream->AddRef();
IHeaderStream=new TIMemoryStream(sh);
IHeaderStream->AddRef();
// Create the module!
TIModuleInterface *mi=tools->CreateCppModule(ModuleName->Text,
       FormName->Text,AncestorClass->Text,FileSystem->Text,
       cHeaderSource->Checked?IHeaderStream:NULL,cSource->Checked?ISourceStream:NULL,
       cForm->Checked?IFormStream:NULL,mf);
// Clean up
ISourceStream->OwnStream=true;
delete ISourceStream;
IFormStream->OwnStream=true;
delete IFormStream;
IHeaderStream->OwnStream=true;
delete IHeaderStream;
if (mi==NULL)
{ Application->MessageBox("Module interface doesn't exist","Error",MB_OK);
}
else
{ // mi->AddRef probably not needed
  TModuleForm *moduleform=new TModuleForm(this);
  moduleform->mi=mi;
  moduleform->Caption=ModuleName->Text;
  moduleform->ShowModal();
  delete moduleform;
  mi->Release();
}
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetProjectNameClick(TObject *Sender)
{
rGetProjectName->Caption=tools->GetProjectName();
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetUnitCountClick(TObject *Sender)
{
rGetUnitCount->Caption=AnsiString(tools->GetUnitCount());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetUnitNameClick(TObject *Sender)
{
rGetUnitName->Caption=tools->GetUnitName(tGetUnitName->Text.ToInt());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetFormCountClick(TObject *Sender)
{
rGetFormCount->Caption=AnsiString(tools->GetFormCount());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetFormNameClick(TObject *Sender)
{
rGetFormName->Caption=tools->GetFormName(tGetFormName->Text.ToInt());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetCurrentFileClick(TObject *Sender)
{
rGetCurrentFile->Caption=tools->GetCurrentFile();
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::IsFileOpenClick(TObject *Sender)
{
rIsFileOpen->Caption=tools->IsFileOpen(tIsFileOpen->Text) ? "true" : "false";
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetNewModuleNameClick(TObject *Sender)
{
AnsiString u,f;
rGetNewModuleName3->Caption=tools->GetNewModuleName(u,f) ? "true" : "false";
rGetNewModuleName1->Caption="unit:"+u;
rGetNewModuleName2->Caption="form:"+f;
}
//---------------------------------------------------------------------------
bool __stdcall EnumProc(void *Param,const AnsiString fl,const AnsiString u,const AnsiString fo)
{ TStringList *sl=(TStringList *)Param;
  AnsiString c="";
  if (fl!="") c=c+"file="+fl;
  if (u!="") {if (c!="") c=c+",    "; c=c+"unit="+u;}
  if (fo!="") {if (c!="") c=c+",    "; c=c+"form="+fo;}
  sl->Add(c);
  return true;
}
void __fastcall TToolsForm::EnumProjectUnitsClick(TObject *Sender)
{ TStringList *sl=new TStringList();
  tools->EnumProjectUnits(EnumProc,sl);
  rEnumProjectUnits->Items->Assign(sl);
  delete sl;
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::rEnumProjectUnitsClick(TObject *Sender)
{ if (rEnumProjectUnits->ItemIndex==-1) return;
  AnsiString s=rEnumProjectUnits->Items->Strings[rEnumProjectUnits->ItemIndex];
  int pos1,pos2; AnsiString t;
  pos1=s.Pos("file="); if (pos1==0) tGetModuleInterface->Text="";
  else
  { pos1=pos1+5; t=s.SubString(pos1,s.Length()-pos1+1); pos2=t.Pos(",");
    if (pos2!=0) t=t.SubString(1,pos2-1);
    tGetModuleInterface->Text=t;
  }
  pos1=s.Pos("form="); if (pos1==0) tGetFormModuleInterface->Text="";
  else
  { pos1=pos1+5; t=s.SubString(pos1,s.Length()-pos1+1); pos2=t.Pos(",");
    if (pos2!=0) t=t.SubString(1,pos2-1);
    tGetFormModuleInterface->Text=t;
  }
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::rEnumProjectUnitsDblClick(TObject *Sender)
{ AnsiString f=tGetFormModuleInterface->Text;
  if (f=="") GetModuleInterfaceClick(this);
  else GetFormModuleInterfaceClick(this);
}

//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetModuleCountClick(TObject *Sender)
{
rGetModuleCount->Caption=AnsiString(tools->GetModuleCount());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetModuleNameClick(TObject *Sender)
{
rGetModuleName->Caption=tools->GetModuleName(tGetModuleName->Text.ToInt());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetComponentCountClick(TObject *Sender)
{
rGetComponentCount->Caption=AnsiString(tools->GetComponentCount(tGetComponentCount->Text.ToInt()));
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetComponentNameClick(TObject *Sender)
{
rGetComponentName->Caption=tools->GetComponentName(tGetComponentName1->Text.ToInt(),tGetComponentName2->Text.ToInt());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetModuleInterfaceClick(TObject *Sender)
{
TIModuleInterface *mi=tools->GetModuleInterface(tGetModuleInterface->Text);
if (mi==NULL)
{ Application->MessageBox("Module interface doesn't exist","Error",MB_OK);
}
else
{ // probably not needed mi->AddRef();
  TModuleForm *moduleform=new TModuleForm(this);
  moduleform->mi=mi;
  moduleform->Caption=tGetModuleInterface->Text;
  moduleform->ShowModal();
  delete moduleform;
  mi->Release();
}
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetFormModuleInterfaceClick(TObject *Sender)
{ TIModuleInterface *mi=tools->GetFormModuleInterface(tGetFormModuleInterface->Text);
  if (mi==NULL)
  { Application->MessageBox("Module interface doesn't exist","Error",MB_OK);
  }
  else
  { // mi->Addref probably not needed
    TModuleForm *moduleform=new TModuleForm(this);
    moduleform->mi=mi;
    moduleform->Caption=tGetFormModuleInterface->Text;
    moduleform->ShowModal();
    delete moduleform;
    mi->Release();
  }
}
//---------------------------------------------------------------------------

void __fastcall TToolsForm::FormCreate(TObject *Sender)
{ ToolPropSheet->ActivePage=tsQuick;
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::BtnAboutClick(TObject *Sender)
{ Application->MessageBox("Tools Services Browser is (c) 1997-1999 Lucian Wischik\r\n\r\n"
              "See README.TXT for more details. To contact the author, email ljw1004@cam.ac.uk "
              "or go to his C++Builder web page at www.wischik.com/lu/programmer.html",
              "Tool Services Browser",MB_OK);
}
//---------------------------------------------------------------------------

void __fastcall TToolsForm::GetMainMenuClick(TObject *Sender)
{
  TIMainMenuIntf *mmi=tools->GetMainMenu();
  if (mmi==NULL)
  { Application->MessageBox("Main menu doesn't exist","Error",MB_OK);
  }
  else
  { // mmi->Addref probably not needed
    TMainMenuForm *menuform=new TMainMenuForm(this);
    menuform->mmi=mmi;
    menuform->ShowModal();
    delete menuform;
    mmi->Release();
  }
}


//---------------------------------------------------------------------------

void __fastcall TToolsForm::btnAddNotifierClick(TObject *Sender)
{ TProjectNotifierForm *mn=new TProjectNotifierForm(Application);
  mn->Show();
}
//---------------------------------------------------------------------------

void __fastcall TToolsForm::btnResourcesClick(TObject *Sender)
{ AnsiString fn=ToolServices->GetProjectName();
  TIModuleInterface *mi=ToolServices->GetModuleInterface(fn);
  if (mi==NULL)
  { Application->MessageBox("Main project module not found","Error",MB_OK);
  }
  else
  { TIResourceFile *rf=mi->GetProjectResource();
    if (rf==NULL)
    { Application->MessageBox("Project Resource not found","Error",MB_OK);
    }
    else
    { TModuleForm *mf=new TModuleForm(this);
      mf->mi=mi; mf->Show();
      TResourceFileForm *f=new TResourceFileForm(this);
      f->rf=rf;
      f->ShowModal();
      rf->Release();
      mf->Hide(); mf->ShowModal();
    }
    mi->Release();
  }
}
//---------------------------------------------------------------------------

